package com.ionspin.kotlin.crypto.mac

import com.ionspin.kotlin.crypto.util.hexColumsPrint
import kotlin.test.Test
import kotlin.test.assertTrue

/**
 * Created by Ugljesa Jovanovic
 * ugljesa.jovanovic@ionspin.com
 * on 17-Jun-2020
 */
class XChaCha20Poly1305Test {
    @Test
    fun debugTest() {
        XChaCha20Poly1305Pure.poly1305Authenticate(
            UByteArray(32) { if (it < 16) { 0U } else {1U} },
            UByteArray(37) { it.toUByte() },
        )
    }

    /**
     * From RFC7539
     */
    @Test
    fun testPoly1305() {
        val key = ubyteArrayOf(
            0x85U, 0xd6U, 0xbeU, 0x78U, 0x57U, 0x55U, 0x6dU, 0x33U, 0x7fU, 0x44U, 0x52U, 0xfeU, 0x42U, 0xd5U, 0x06U,
            0xa8U, 0x01U, 0x03U, 0x80U, 0x8aU, 0xfbU, 0x0dU, 0xb2U, 0xfdU, 0x4aU, 0xbfU, 0xf6U, 0xafU, 0x41U, 0x49U,
            0xf5U, 0x1bU
        )
        val message = ubyteArrayOf(
            0x43U, 0x72U, 0x79U, 0x70U, 0x74U, 0x6fU, 0x67U, 0x72U, 0x61U, 0x70U, 0x68U, 0x69U, 0x63U, 0x20U, 0x46U, 0x6fU,
            0x72U, 0x75U, 0x6dU, 0x20U, 0x52U, 0x65U, 0x73U, 0x65U, 0x61U, 0x72U, 0x63U, 0x68U, 0x20U, 0x47U, 0x72U, 0x6fU,
            0x75U, 0x70U
        )
        val expected = ubyteArrayOf(
            0xA8U, 0x06U, 0x1DU, 0xC1U,
            0x30U, 0x51U, 0x36U, 0xC6U,
            0xC2U, 0x2BU, 0x8BU, 0xAFU,
            0x0CU, 0x01U, 0x27U, 0xA9U,
        )

        val result = XChaCha20Poly1305Pure.poly1305Authenticate(
            key,
            message,
        )
        assertTrue {
            expected.contentEquals(result)
        }
    }
}